//
// Vrml  written by Kenji Shimada
// Modified by Arbtip Dheeravongkit
// Problem Set 9 Sample Code 
//

import java.io.*;

public class Vrml {

    public Vrml(String file, String name) throws IOException {
	outFile = new PrintWriter (new FileWriter (file));
	myName = name;
    }

public void vrml_reg (double a[], double data[][])throws IOException{
// Draw in the output vrml file, axes, data points, and surface
//  outFile: pointer to the output vrml file
//  my_name: my name to be shown in the heading
//	a[]:     coefficients of qadratic surface
	
	int			i, j;
	double		x1, x2;

	// Create Header
	outFile.print( "#VRML V2.0 utf8\n");
	outFile.print( "#------------------------------------------------\n");
	outFile.print( "# 24-311: Numerical Methods  Fall'98\n");
	outFile.print( "# ");
	outFile.print(myName);
	outFile.print("\n");
	outFile.print( "# Two Dimensional Quadratic Regression\n");
	outFile.print( "#------------------------------------------------\n\n");

	// Set up background
	outFile.print( "# Specify the background color\n");
	outFile.print( "#-----------------------------------\n");
	outFile.print( "Background {\n\tskyColor 1 1 1\n}\n\n"); // White background

	// Create the square for the canvas
//	outFile.print( "# Draw the first canvas\n";
//	outFile.print( "#-----------------------------------\n";
//	outFile.print( "Transform {\n";
//	outFile.print( "\trotation 1 0 0 1.5707\n";
//	outFile.print( "\ttranslation 10 0 10\n";
//	outFile.print( "\tchildren Shape {\n";
//	outFile.print( "\t\tappearance Appearance {\n";
//	outFile.print( "\t\t\tmaterial Material {\n";
//	outFile.print( "\t\t\t\tdiffuseColor 0.0 0.9 0.9\n";
//	outFile.print( "\t\t\t\ttransparency 0.5\n\t\t\t}\n\t\t}\n";
//	outFile.print( "\t\tgeometry Box {\n";
//	outFile.print( "\t\t\tsize 20 20 0.1\n\t\t}\n\t}\n}\n\n";

	// Put text heading on the VRML screen
	outFile.print( "# Draw texts\n");
	outFile.print( "#-----------------------------------\n");
	outFile.print( "Transform {\n");
	outFile.print( "\ttranslation 10 26 1\n");
	outFile.print( "\tchildren Shape {\n");
	outFile.print( "\t\tappearance Appearance {\n");
	outFile.print( "\t\t\tmaterial Material {\n");
	outFile.print( "\t\t\t\tdiffuseColor 1 0 0\n");
	outFile.print( "\t\t\t}\n\t\t}\n");
	outFile.print( "\t\tgeometry Text {\n");
	outFile.print( "\t\t\tstring [\"24-311: Numerical Methods--PS7\",\n");
	outFile.print( "\t\t\t\"2D Quadratic Regression\",\n");
	outFile.print( "\t\t\t\"");
	outFile.print(myName);
	outFile.print("\"]\n");
	outFile.print( "\t\t\tfontStyle FontStyle {\n");
	outFile.print( "\t\t\t\tfamily \"SANS\"\n");
	outFile.print( "\t\t\t\tjustify \"MIDDLE\"\n");
	outFile.print( "\t\t\t\tstyle \"BOLD\"\n");
	outFile.print( "\t\t\t\tsize 1.5\n\t\t\t}\n\t\t}\n\t}\n}\n\n");

	// Add the x-axis
	outFile.print( "# Define the x axis\n");
	outFile.print( "#-----------------------------------\n");
	outFile.print( "Transform {\n");
	outFile.print( "\ttranslation 0 0 0\n");
	outFile.print( "\tchildren DEF AXIS Shape {\n");
	outFile.print( "\t\tappearance Appearance {\n");
	outFile.print( "\t\t\tmaterial Material {\n");
	outFile.print( "\t\t\t\tdiffuseColor 0.0 0.0 0.0\n\t\t\t}\n\t\t}\n");
	outFile.print( "\t\tgeometry Extrusion {\n");
	outFile.print( "\t\t\tcrossSection [1 0, 0 -1, -1 0, 0 1, 1 0]\n");
	outFile.print( "\t\t\tscale [0.1 0.1, 0.1 0.1, 0.4 0.4, 0 0]\n");
	outFile.print( "\t\t\tspine [0 0 0, 21 0 0, 21 0 0, 22 0 0]\n\t\t}\n\t}\n}\n\n");

	// Add the y-axis
	outFile.print( "# Draw the y axis\n");
	outFile.print( "#-----------------------------------\n");
	outFile.print( "Transform {\n");
	outFile.print( "\trotation 0 0 1 1.5707\n");
	outFile.print( "\tchildren USE AXIS\n}\n\n");

	// Add the z-axis
	outFile.print( "# Draw the z axis\n");
	outFile.print( "#-----------------------------------\n");
	outFile.print( "Transform {\n");
	outFile.print( "\trotation 0 1 0 -1.5707\n");
	outFile.print( "\tchildren USE AXIS\n}\n\n");

	// Draw data points
	outFile.print( "# Draw data points\n");
	outFile.print( "#-----------------------------------\n");
	for(i=0; i<6; i++)
		for(j=0; j<6; j++){
			outFile.print( "Transform {\n");
			outFile.print( "\ttranslation ");
			outFile.print(j*4.0); 
			outFile.print(" ");
			outFile.print(20.0*data[i][j]);
			outFile.print(" ");
			outFile.print(i*4.0);
			outFile.print("\n");
			outFile.print( "\tchildren Shape {\n");
			outFile.print( "\t\tappearance Appearance {\n");
			outFile.print( "\t\t\tmaterial Material {\n");
			outFile.print( "\t\t\t\tdiffuseColor 1.0 0.0 0.0\n");
			outFile.print( "\t\t\t}\n");
			outFile.print( "\t\t}\n");
			outFile.print( "\t\tgeometry Sphere {\n");
			outFile.print( "\t\t\tradius 0.5\n\t\t}\n\t}\n}\n\n");
		}

	// Draw the surface
	outFile.print( "# Draw the surface\n");
	outFile.print( "#-----------------------------------\n");
	outFile.print( "Transform {\n");
	outFile.print( "\ttranslation 0 0 0\n");
	outFile.print( "\tchildren Shape {\n");
	outFile.print( "\t\tappearance Appearance {\n");
	outFile.print( "\t\t\tmaterial Material {\n");
	outFile.print( "\t\t\t\tdiffuseColor 0.0 1.0 0.0\n");
	outFile.print( "\t\t\t\ttransparency 0.25\n");
	outFile.print( "\t\t\t}\n\t\t}\n");
	outFile.print( "\t\tgeometry ElevationGrid{\n");
	outFile.print( "\t\t\tsolid FALSE\n");
	outFile.print( "\t\t\txDimension ");
	outFile.print( SURF_PREC );
	outFile.print("\n");
	outFile.print( "\t\t\tzDimension ");
	outFile.print( SURF_PREC );
	outFile.print("\n");
	outFile.print( "\t\t\txSpacing " );
	outFile.print( X_SPACING );
	outFile.print("\n");
	outFile.print( "\t\t\tzSpacing ");
	outFile.print(Y_SPACING);
	outFile.print("\n");
	outFile.print( "\t\t\theight [");
	for (i=0; i<SURF_PREC; i++)
		for (j=0; j<SURF_PREC; j++){
			x1=i/(double) SURF_PREC;
			x2=j/(double) SURF_PREC;
			outFile.print( 20.0*( a[0] + a[1]*x1 + a[2]*x2 
					     + a[3]*x1*x2 + a[4]*x1*x1 + a[5]*x2*x2));
			outFile.print(", ");
		}
		
	outFile.print( "]\n");

	outFile.print( "\n\t\t}\n\t}\n}\n\n");

}

    public void VrmlClose() throws IOException {
	outFile.close();
    }

    //class variables
    private PrintWriter outFile;
    private String myName;

    //Constants
    private final double DRAW_WIDTH=0.2;
    private final int SURF_PREC = 21;
    private final double X_SPACING = 1.0;
    private final double Y_SPACING = 1.0;


}






